Bug 45986 - [info]...Invalid argument: core_output_filter: writing data to the network
Summary: [info]...Invalid argument: core_output_filter: writing data to the network
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: Core (show other bugs)
Version: 2.0.63
Hardware: All All
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2008-10-10 08:24 UTC by Danijel Tasov
Modified: 2018-11-07 21:09 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Danijel Tasov 2008-10-10 08:24:43 UTC
Hello,

today, I was debugging a CGI application, which after logging in, writes
some HTML data to the document root and redirects the client to it.

But the redirection was not successful, the request was answered with a
closed connection. The entire response was missing.

Since this runs on a clustered environment (DocumentRoot is shared over
NFS), I thought this was an NFS problem, because I could receive the
content on the second server. Long story short, I was off the track.

After I set the LogLevel to debug the following message appeared in the
ErrorLog:

  [info] [client 160.xx.xx.xx] (22)Invalid argument: core_output_filter: writing data to the network

I grepped the httpd source for this message to get an idea what's going
on here and found the FAQ entry. EnableSendfile Off, everything is fine
now.

But I really think that this should be at least an error instead of an
info. httpd was not able to send the response, this is worse than "file
not found" which is logged as an error.

Here is the patch:
--- server/core.c.orig  2006-07-12 09:40:55.000000000 +0200
+++ server/core.c       2008-10-10 17:21:36.000000000 +0200
@@ -4327,7 +4327,7 @@
         }
 
         if (rv != APR_SUCCESS) {
-            ap_log_cerror(APLOG_MARK, APLOG_INFO, rv, c,
+            ap_log_cerror(APLOG_MARK, APLOG_ERR, rv, c,
                           "core_output_filter: writing data to the network");
 
             if (more)

Regards,
Danijel
Comment 1 Eric Covener 2008-10-10 08:47:45 UTC
I'd rather see it trap the specific errno, because this looks like the same path as a host of normal client issues which I don't agree should be loglevel error.
Comment 2 Danijel Tasov 2008-10-21 12:15:47 UTC
Hm, I see the problem. I agree with Marc.

       EAGAIN Non-blocking I/O has been  selected  using  O_NONBLOCK  and  the
              write would block.

       EBADF  The input file was not opened for reading or the output file was
              not opened for writing.

       EFAULT Bad address.

       EINVAL Descriptor is not valid or locked, or an mmap(2)-like  operation
              is not available for in_fd.

       EIO    Unspecified error while reading from in_fd.

       ENOMEM Insufficient memory to read from in_fd.

This are the errors sendfile could raise. At least an error should be
logged, if sendfile raises EIO, ENOMEN or EINVAL

I'm not sure about about EFAULT, EBADF and EGAIN.
Comment 3 Eric Covener 2008-10-22 06:45:29 UTC
(In reply to comment #2)
> Hm, I see the problem. I agree with Marc.

> This are the errors sendfile could raise. At least an error should be
> logged, if sendfile raises EIO, ENOMEN or EINVAL


This log message is not sendfile-specific, though.
Comment 4 William A. Rowe Jr. 2018-11-07 21:09:58 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.